import React from 'react';
import Card from './Card.js';
import './Board.css';

class Board extends React.Component {
    constructor(props) {
        super(props)
        const fronts = [
            '🥑',
            '🍒',
            '🍑',
            '🍋',
            '🥦',
            '🥥',
            '🍉',
            '🍇',
            '🍐',
            '🍌',
            '🍓',
            '🍍',
        ]
    
        const deck = fronts
        .concat(fronts)
        .sort(() => Math.random() - 0.5)
        .map(f => {
            return {
                content: f,
                faceUp: false
            }
        })

        this.state = {
            deck: deck,
            firstCard: null, 
        }
    }

    flipCardTo(cardIdX) {
        this.setState({
            deck: this.state.deck.map((f, i) => {
                if(i === cardIdX) {
                    return {
                        content: f.content,
                        faceUp: !f.faceUp
                    }
                } else {
                    return f;
                }
            })
        })
    }

    flip(cardIdX) {
        if(this.state.firstCard === null) {
            this.setState({firstCard: cardIdX})
        } else {
            const firstCardContent = this.state.deck[this.state.firstCard].content;
            const secondCardContent = this.state.deck[cardIdX].content;
            console.log(firstCardContent, secondCardContent);
            if(firstCardContent === secondCardContent) {
                console.log('Same!')
                this.setState({firstCard: null});
            } else {
                console.log(`Different: ${firstCardContent} != ${secondCardContent}`)
                setTimeout(() => {
                    this.flipCardTo(this.state.firstCard, false)
                    this.flipCardTo(cardIdX, false)
                    this.setState({firstCard: null})
                }, 3000)
            }
        }

        this.flipCardTo(cardIdX, !this.state.deck[cardIdX].faceUp)
    }    

    render() {
        console.log(this.state.firstCard);
        return (
            this.state.deck.map((f, i) => {
                return (<div className='Board'>
                    <Card
                        flip={() => {this.flip(i)}} 
                        content={f.content} 
                        faceUp={f.faceUp} />
                    </div>)
            })
        )
    }
}

export default Board;